require "defines"
require "config"
-----------------------------------------------------------------------------------------------------------------------
script.on_init(function()
	set_handlers()
end)
 
script.on_load(function()
	set_handlers()
end)
 
function set_handlers()
	script.on_event(defines.events.on_built_entity, build_entity_handler)
	script.on_event(defines.events.on_robot_built_entity, build_entity_handler)
	script.on_event(defines.events.on_preplayer_mined_item, break_entity_handler)
	script.on_event(defines.events.on_robot_pre_mined, break_entity_handler)
	script.on_event(defines.events.on_entity_died, break_entity_handler)
	script.on_event(defines.events.on_player_mined_item, break_entity_handler)
	script.on_event(defines.events.on_robot_mined, break_entity_handler)
	script.on_event(defines.events.on_tick, process_tick)
end

-----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------Methoden-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function get_lgt (e, recover)
	for i, lgt in pairs(global.lgts) do
		if e == lgt.chest then
			return lgt, i
		end
	end
	return nil, nil
end

-----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------Variablen----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
ilgt = {}
--ilgt["lgt-name"] = {ctype="lgt-name", ttype="turret-name", ammo=lgt_config["ammo-turret-Number"], count = lgt_config["count-turret-Number"], health=max_health}
ilgt["logistic-gun-turret"] = {ctype="logistic-gun-turret", ttype="gun-turret", ammo=lgt_config["ammo_t1"], count = lgt_config["count_t1"], health=400}

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Build-Event-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function build_entity_handler(event)
	local e = event.created_entity 
	if e == nil or not ilgt[e.name] then return end
	local info = ilgt[e.name]
	local s = e.surface
	local p = e.position
	local f = e.force
	local h = e.health
	local t = s.create_entity{name = info.ttype, position = p, force = f}
	e.destroy()
	local c = s.create_entity{name = info.ctype, position = p, force = f}
	t.minable = false
	t.destructible = false
	t.operable = false
	t.health = h
	c.health = h
	c.set_request_slot ({name=info.ammo, count=info.count}, 1)
	local lgt = {turret=t, chest=c}
	if global.lgts == nil then global.lgts = {} end
	table.insert(global.lgts, lgt)
end

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Break-Event-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function break_entity_handler(event)
	local e = event.entity	
	if e == nil or not ilgt[e.name] then return end
	local lgt,i = get_lgt(e,true)
	if lgt == nil then return end
	table.remove(global.lgts, i)
	if lgt.turret.valid == false then return end
	if not lgt.turret.get_inventory(1).is_empty() then lgt.chest.insert(lgt.turret.get_inventory(1)[1]) end
	lgt.turret.destroy()
end

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Tick-Event------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function process_tick(event)
	if event.tick % 15 ~= 0 or global.lgts == nil then return end
	for i, lgt in pairs(global.lgts) do
		if lgt.chest == nil or lgt.turret == nil or lgt.turret.valid == false then return end
		local h = ilgt[lgt.chest.name].health
		local turret_inv = lgt.turret.get_inventory(1)
    	if turret_inv.is_empty() then
        	local chest_inv = lgt.chest.get_inventory(1)
        	if not chest_inv.is_empty() then
            	local item = chest_inv[1]
            	if item.prototype.type == "ammo" and item.count > 0 and lgt.turret.can_insert(item) then
                	lgt.turret.insert({name = item.prototype.name, count = 1})
                	item.count = item.count - 1
            	end
        	end
        end
    end
end